# This creates a policy that's scoped to a specific database

trap [Exception]
{
  write-host "Trapped Exception"
  write-host $_.Exception.Message
  write-host $_.Exception.InnerException.Message
}

#$ErrorActionPreference = 'SilentlyContinue'

$p1 = new-object ($dmf + 'Policy') $pol, "CreateFinanceTab2"
$p1.Condition = "TablePattern"
$p1.AutomatedPolicyEvaluationMode = [Microsoft.SqlServer.Management.Dmf.AutomatedPolicyEvaluationMode]::None

$os = new-object ($dmf + 'ObjectSet') $pol, "CheckFinanceTab_ObjectSet2"
$os.Facet = "IMultipartNameFacet"

$ts1 = $os.TargetSets["Server/Database/Table"]
$ts1.Enabled = $true

$tsl = $ts1.GetLevel("Server/Database")
$ts1.SetLevelCondition($tsl, "FinanceDB")

$os.Create()

$p1.ObjectSet = "CheckFinanceTab_ObjectSet2"

$p1.Create()
#$p1

